{   This file is a part of Witch7DRL, the roguelike game.
    Copyright (C) 2011 Konovod Andrey (kipar@front.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/
}
unit uManual;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type


  TManuscriptPage = (Intro, Welcome, Source, Line, Barrier, Channel, FireField, Heal, Demon, FreeDemon, Golem, START);


  { TfmManual }

  TfmManual = class(TForm)
    btPrev: TButton;
    btNext: TButton;
    btLast: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    procedure btLastClick(Sender: TObject);
    procedure btLastMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btNextClick(Sender: TObject);
    procedure btNextMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btPrevClick(Sender: TObject);
    procedure btPrevMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    CurPage: TManuscriptPage;
    procedure SetPage(N: TManuscriptPage);

    { public declarations }
  end; 

var
  fmManual: TfmManual;

implementation

uses uClass, uMain;

{$R *.lfm}

{ TfmManual }

procedure TfmManual.btNextClick(Sender: TObject);
begin
end;

procedure TfmManual.btNextMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if CurPage = START then
  begin
    fmManual.Close;
    THEGAME.WasWarped := False;
    THEGAME.ClearTransTable;
    THEGAME.GenTransTable;
    THEGAME.GenLevel;
    form1.SetFocus;
  end
  else
    SetPage(Succ(CurPage));
end;

procedure TfmManual.btLastClick(Sender: TObject);
begin
end;

procedure TfmManual.btLastMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SetPage(START);
end;

procedure TfmManual.btPrevClick(Sender: TObject);
begin
end;

procedure TfmManual.btPrevMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  SetPage(Pred(CurPage));
end;

procedure TfmManual.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose := CurPage = START;
end;

procedure TfmManual.FormCreate(Sender: TObject);
begin
end;

procedure TfmManual.FormShow(Sender: TObject);
begin
  SetPage(Intro);
  THEGAME.ClearTransTable;
end;

procedure TfmManual.SetPage(N: TManuscriptPage);
begin
  Left := Form1.Width - Width;
  CurPage := N;
  Memo1.Lines.LoadFromFile('.\plot\'+IntToStr(Integer(N))+'.dat');
  Memo1.Lines.Delete(0);
  case CurPage of
  Intro:
    begin
      btPrev.Visible := False;
      btNext.Visible := True;
      btLast.Visible := False;
      btNext.Caption := 'Открыть книгу';
    end;
  Welcome:
    begin
      btPrev.Visible := False;
      btNext.Visible := True;
      btLast.Visible := True;
      btNext.Caption := 'Следующая страница';
    end;
  Source:
    begin
      btPrev.Visible := True;
      THEGAME.LoadLevel('room1.game');
    end;
  Line, Barrier, Channel, FireField, Heal, Demon, Golem:
    THEGAME.LoadLevel('room1.game');
  FreeDemon: THEGAME.LoadLevel('room2.game');

  START:
    begin
      btPrev.Visible := False;
      btNext.Visible := True;
      btLast.Visible := False;
      btNext.Caption := 'Начать игру';
    end;
  end;
  Form1.SetFocus;
end;

end.

